#include "../headers/typedefs.h"
#include "../headers/MPC5777m.h"
void DMA_Init(void);

vuint32_t SDADC1_RESULTS[50];
volatile uint32_t sfr[];
		

/****************** Configure the DMA - Loop of transfers ********************/
void DMA_Init(void)
{


//Configure SDADC Mux  channels
 DMACHMUX_2.CHCONFIG[0].R= 0x82;                         	//Configures the DMA MUX 2 to set SDADC1 EOC on DMA channel 16



/* Configure CH16 */
 // DMA_0.TCD[16].SADDR = (vuint32_t)((uint16_t *)&SDADC_1.CDR.R +1);
 // DMA_0.TCD[16].SMOD = 0;    
 // DMA_0.TCD[16].SSIZE = 0x1; /* 16-bit */
 // DMA_0.TCD[16].DMOD = 0;
 // DMA_0.TCD[16].DSIZE = 0x1; /* 16-bit */
 // DMA_0.TCD[16].SOFF = 0;
 // DMA_0.TCD[16].NBYTES = 2; /* 2x 8 bits = 16bits */
 // DMA_0.TCD[16].SLAST = 0;
 // DMA_0.TCD[16].DADDR = (vuint32_t)((uint16_t *)&SDADC1_RESULTS);
 // DMA_0.TCD[16].CITER_ELINK = 0;     
 // DMA_0.TCD[16].CITER_LINKCH = 0;
 // DMA_0.TCD[16].CITER = 100;
 // DMA_0.TCD[16].DOFF = 0x2;
 // DMA_0.TCD[16].DLAST_SGA = -200;
 // DMA_0.TCD[16].BITER = 100;
 // DMA_0.TCD[16].BITER_ELINK = 0;
 // DMA_0.TCD[16].BITER_LINKCH = 0;
 // DMA_0.TCD[16].BWC = 0;    
 // DMA_0.TCD[16].MAJORLINKCH = 0; /*No Linking */
 // DMA_0.TCD[16].MAJORELINK = 0; 
 // DMA_0.TCD[16].ESG = 0;
 // DMA_0.TCD[16].DREQ = 1;
 // DMA_0.TCD[16].INTHALF = 0;
 // DMA_0.TCD[16].INTMAJ = 0;

/* Configure CH16 */
 DMA_0.TCD[16].SADDR = (vuint32_t)&SDADC_1.CDR.R +2;
 DMA_0.TCD[16].SMOD = 0x2;    
 DMA_0.TCD[16].SSIZE = 0x1; /* 16-bit */
 DMA_0.TCD[16].DMOD = 0x2;
 DMA_0.TCD[16].DSIZE = 0x1; /* 16-bit */
 DMA_0.TCD[16].SOFF = 0;
 DMA_0.TCD[16].NBYTES = 2; /* 2x 8 bits = 16bits */
 DMA_0.TCD[16].SLAST = 0;
 DMA_0.TCD[16].DADDR = (vuint32_t)&SDADC1_RESULTS;
 DMA_0.TCD[16].CITER_ELINK = 1;     
 DMA_0.TCD[16].CITER_LINKCH = 17;
 DMA_0.TCD[16].CITER = 100;
 DMA_0.TCD[16].DOFF = 0x2;
 DMA_0.TCD[16].DLAST_SGA = -200;
 DMA_0.TCD[16].BITER = 100;
 DMA_0.TCD[16].BITER_ELINK = 1;
 DMA_0.TCD[16].BITER_LINKCH = 17;
 DMA_0.TCD[16].BWC = 0;    
 DMA_0.TCD[16].MAJORLINKCH = 17; /*No Linking */
 DMA_0.TCD[16].MAJORELINK = 1; 
 DMA_0.TCD[16].ESG = 0;
 DMA_0.TCD[16].DREQ = 1;
 DMA_0.TCD[16].INTHALF = 0;
 DMA_0.TCD[16].INTMAJ = 0;
 
 DMA_0.TCD[17].SADDR = (vuint32_t)&SDADC_1.SFR.R;	/* Source address is SDADC_1.SFR.R */
    DMA_0.TCD[17].SMOD = 0; 				/* Source address modulo is disabled */
    DMA_0.TCD[17].SSIZE = 0x2; 				/* Source data transfer size 32-bit */
    DMA_0.TCD[17].DMOD = 0; 				/* Destination address modulo is disabled */
    DMA_0.TCD[17].DSIZE = 0x2; 				/* Destination data transfer size 32-bit */
    DMA_0.TCD[17].SOFF = 0; 				/* Source address signed offset is 0 */
    DMA_0.TCD[17].NBYTES = 4; 				/* Minor byte transfer count 32bits = 4bytes */
    DMA_0.TCD[17].SLAST = 0; 				/* Last source address adjustment */
    DMA_0.TCD[17].DADDR = (uint32_t)sfr; 		/* Destination address */
    DMA_0.TCD[17].CITER_ELINK = 0;  			/* Enable channel-to-channel linking on minor-loop complete if 1 */
    DMA_0.TCD[17].CITER_LINKCH = 0; 			/* Link channel number */
    DMA_0.TCD[17].CITER = 1; 		/* Current major iteration count */
    DMA_0.TCD[17].DOFF = 0x4; 				/* Destination address signed offset */
    DMA_0.TCD[17].DLAST_SGA = 0; 			/* Destination last address adjustment or the memory address for the next transfer control descriptor to be loaded into this channel(scatter/gather) */
    DMA_0.TCD[17].BITER = 1; 				/* Starting major iteration count */
    DMA_0.TCD[17].BITER_ELINK = 0; 			/* Enables channel-to-channel linking on minor loop complete if 1 */
    DMA_0.TCD[17].BITER_LINKCH = 0; 			/* Link channel number */
    DMA_0.TCD[17].BWC = 0; 				/* Bandwidth control. No eDMA engine stalls */
    DMA_0.TCD[17].MAJORLINKCH = 0; 			/* Link channel number. No channel to channel linking */
    DMA_0.TCD[17].MAJORELINK = 0; 			/* Disable channel linking */
    DMA_0.TCD[17].ESG = 0; 				/* Disable scatter/gather processing */
    DMA_0.TCD[17].DREQ = 1; 				/* Disable request{H,L}. The channel's ERQ bit is not effected */
    DMA_0.TCD[17].INTHALF = 0; 				/* Disable an interrupt of major counter is half complete */
    DMA_0.TCD[17].INTMAJ = 0; 				/* Enable an interrupt of major iteration count complete */

/* Enable channels */
 //DMA_0.ERQL.R = 0x00010080;                        //Enable channels 7 and 16 for SDADC eDMA requests
  DMA_0.ERQL.R |= 0x00030000;
 
}/* DMA_Init */
