/*************************** Interrupt Service Routines *********************************/
#include "../../headers/project.h"

extern uint32_t duty_PIT;
extern uint32_t dn1_PIT;
extern uint8_t phase_PIT;
extern uint32_t rx_duty;

extern	 void txEthernetFrame(void);

extern vuint16_t SDADC1_RESULTS[];
 
/* PIT0 CH5 */
 void IRQ_PIT0_CH5 (void){

 PIT_0.TIMER[5].TFLG.B.TIF = 0x1;		/* clear timer 0 channel 5 interrupt flag */
 SDADC_1.SFR.B.DFFF = 0x1;			/*write 1 to clear and prompt new sample*/ 
 if(phase_PIT == 0x00){
	duty_PIT = rx_duty;
	duty_PIT -= 0xC000;
	duty_PIT &= 0x0000FFFF;
	duty_PIT = duty_PIT << 1;
	PIT_0.TIMER[5].LDVAL.R = duty_PIT;		/*load duty value to timer*/
	dn1_PIT = 0xFFFF - duty_PIT;			/*calculate end of duty value (incase duty changes between ints)*/
	phase_PIT = 0x01;
	SIUL2.GPDO[0].B.PDO = 0;			/*LED ON*/
	}else{
	PIT_0.TIMER[5].LDVAL.R = dn1_PIT;		/*load duty value to timer*/	
	phase_PIT = 0x00;
	SIUL2.GPDO[0].B.PDO = 1;			/*LED OFF*/
	}
 }

void IRQ_PIT0_CH4 (void){
 PIT_0.TIMER[4].TFLG.B.TIF = 0x1;		/* clear timer 0 channel 5 interrupt flag */
 SIUL2.GPDO[1].B.PDO = ~SIUL2.GPDO[1].B.PDO;
 txEthernetFrame();					//transmit ethernet frame
 }