


/*  /$$$$$$  /$$$$$$$         /$$$$$$  /$$$$$$$   /$$$$$$ 
 -  /$$__  $$| $$__  $$       /$$__  $$| $$__  $$ /$$__  $$
 - | $$  \__/| $$  \ $$      | $$  \ $$| $$  \ $$| $$  \__/
 - |  $$$$$$ | $$  | $$      | $$$$$$$$| $$  | $$| $$      
 -  \____  $$| $$  | $$      | $$__  $$| $$  | $$| $$      
 -  /$$  \ $$| $$  | $$      | $$  | $$| $$  | $$| $$    $$
 - |  $$$$$$/| $$$$$$$/      | $$  | $$| $$$$$$$/|  $$$$$$/
 -  \______/ |_______/       |__/  |__/|_______/  \______/ */
                                                        

  														 
/**************************************************************************/
/* FILE NAME: SD_ADC.c   Copyright (c) 2012,     Freescale Semiconductor */ 
/* VERSION:  1.1                                  All Rights Reserved     */
/*                                                                        */
/* DESCRIPTION:                                                           */
/* SD ADC Run IDD Code for MPC5764M                                      */
/*                                                                        */
/*                                                                        */						 
/*                                                                        */
/*========================================================================*/
/* UPDATE HISTORY                                                         */
/* REV      AUTHOR      DATE       DESCRIPTION OF CHANGE                  */
/* ---   -----------  ---------    ---------------------                  */					    
/* 1.0   A.Turner      16/01/12    Initial version for MPC5764M RIDD      */
/* 1.1   A.Turner	   3/12/12	   Included Offset Cal and Gain cal		  */
/**************************************************************************/
#define maxSDADCcurrent

#include "../headers/MPC5777m.h"
#include "../headers/project.h"

//UINT8 adc_pad[NUM_ADC_PAD] = {16,17,18,19,59,77,20,78,79,170,108,107,106,105,171, 169,104,103,135,134,22,23,168,166,102,101,133,132,131,130,167,165,129,128,164,21, 28,29,30,31,163,162,161,160,100,99,98,97,137,136,96,68,67,61,60,66,65,64,32,33

void SDADC_INIT(void); 

extern vuint16_t SDADC1_RESULTS[];

/***************************************************/
/* enable_SDADCs: Use to enable SDADCs             */
/* 												   */
/***************************************************/


void enable_SDADCs (void)                       
{
    SDADC_1.MCR.B.EN = 1;			 //Power up SDADC 1
}
/***************************************************/
/* enable_FRZ: Use to enable SDADC Freezu in debug */
/* 												   */
/***************************************************/

void enable_FRZ (void)                       
{
    // SDADC_0.MCR.B.FRZ = 1;			 //Power up SDADC 0
    // SDADC_1.MCR.B.FRZ = 1;			 //Power up SDADC 1
    // SDADC_2.MCR.B.FRZ = 1;			 //Power up SDADC 2
    // SDADC_3.MCR.B.FRZ = 1;			 //Power up SDADC 3
    // SDADC_4.MCR.B.FRZ = 1;			 //Power up SDADC 4
    // SDADC_5.MCR.B.FRZ = 1;			 //Power up SDADC 5
}
/***************************************************/
/* set_MCR : Edit to configure SDADC conversion    */
/* 												   */
/***************************************************/
void set_MCR (void)
{
    SDADC_1.MCR.B.PDR = 0xB;			 //configure OSR 8MHz /80 = 100KHz. 
	SDADC_1.CSR.R = 0x0;			 //configure CSR 1
	SDADC_1.MCR.B.PGAN = 0x0;			 //configure GAIN
	SDADC_1.MCR.B.EMSEL = 0x0;			 //configure EXT/INT Modulator
	SDADC_1.MCR.B.HPFEN = 0x0;			 //configure Hi Pass filter
	SDADC_1.MCR.B.GECEN = 0x0;			 //Gain calibration mode disabled
	SDADC_1.MCR.B.VCOMSEL = 0x1;		 //Common ref = Vrefn 
	SDADC_1.MCR.B.MODE = 0x1;		 //Single ended   
	SDADC_1.CSR.B.ANCHSEL = 0x0;	     //VrefN connected to INP and INM
}
/****************************************************/
/* OffsetCal :configure SDADC for Offset Calibration*/
/* 												    */
/****************************************************/
void OffsetCal (void)
{     
	SDADC_1.MCR.B.MODE = 0x0;		     //Differential mode 
	SDADC_1.CSR.B.BIASEN = 0x0;		     //ensure no bias connected to analog channel
	SDADC_1.CSR.B.ANCHSEL = 0x4;	     //VrefN connected to INP and INM
    SDADC_1.MCR.B.PDR = 0x04;			 //configure OSR
	SDADC_1.MCR.B.PGAN = 0x1;			 //configure GAIN = 2
	SDADC_1.MCR.B.EMSEL = 0x0;			 //configure EXT/INT Modulator
	SDADC_1.MCR.B.HPFEN = 0x0;			 //configure Hi Pass filter
	SDADC_1.MCR.B.GECEN = 0x0;			 //Gain calibration mode disabled
	SDADC_1.MCR.B.VCOMSEL = 0x0;		 //Common ref = VSS
	
}
/****************************************************/
/* OffsetCal :configure Output settling delay       */
/* 												    */
/****************************************************/

void OSD_config (void)
{
//      SDADC_1.OSDR.R = 0xff;			 //configure OSDR 1
}
/****************************************************/
/* OffsetCal :Set RESET Key. Updates configuration  */
/* 												    */
/****************************************************/
void RESET_KEY (void)
{
    // SDADC_0.RKR.R = 0x5AF0;			 //configure RKR 0    Send the reset key to begin conversions with the new config
     SDADC_1.RKR.R = 0x5AF0;			 //configure RKR 1
    // SDADC_2.RKR.R = 0x5AF0;			 //configure RKR 2
    // SDADC_3.RKR.R = 0x5AF0;			 //configure RKR 3
    // SDADC_4.RKR.R = 0x5AF0;			 //configure RKR 4
    // SDADC_5.RKR.R = 0x5AF0;			 //configure OSDR 5
}
void Start_DMA (void)
{
SDADC_1.RSER.R = 0x00010003;			 //Configure for  DMA  Allow FIFO Full and Overflow IRQs
// SDADC_1.RSER.B.DFFDIRS = 1;  /* Select DMA Request */
// SDADC_1.RSER.B.DFFDIRE = 1;     /* Enable Interrupt/DMA request (SFR[DFFF]) when data FIFO full occurs */ 
// SDADC_1.SFR.B.DFFF = 1;        /* Clear SDADC FIFO Full flag */ 
// SDADC_1.SFR.B.DFORF = 1;        /* Clear SDADC FIFO Overflow flag */ 
}

/********************************************************/
/* FIFO_INIT :Configuration of FIFO size and threshold  */
/* 												        */
/********************************************************/
void FIFO_INIT (void)
{
     SDADC_1.FCR.R = 0x00000101;			 //configure FIFO. 
	// SDADC_1.FCR.B.FE = 1;
 }
/********************************************************/
/* FIFO_INIT :Configuration of FIFO size and threshold  */
/* 												        */
/********************************************************/
void RSER_INIT (void)
{
     //SDADC_1.RSER.R = 0x00000001;			 //Configure for  DMA  Allow FIFO Full and Overflow IRQs
	 SDADC_1.RSER.R = 0x00010003;			 //Configure for  DMA  Allow FIFO Full and Overflow IRQs
 }
/********************************************************/
/* average_results :Average the results of the offset   */
/* 					calibration						    */
/********************************************************/
uint32_t average_results (void)
 {
     uint16_t  i 	 = 0x0;
	 uint32_t temp	 = 0x0;
	 uint16_t data_length = 0x1ff;		//Length of array

while ( DMA_0.TCD[16].DONE ==0)
 {
 }

 for ( i = 0;i<data_length;i++)  
 {
   temp = temp + SDADC1_RESULTS[i];
 }
return (temp/data_length);
}

/********************************************************/
/* SDADC_INIT :Initialize and startSDADC                */
/* 				for normal operations	                */
/********************************************************/
void SDADC_INIT(void)
{
	enable_SDADCs ();
	set_MCR ();
    FIFO_INIT ();
    OSD_config ();
    RSER_INIT (); 
    RESET_KEY ();  
    	
}


// void SDADC_INIT(void)
// {

    // FIFO_INIT ();
    // OSD_config ();
    // set_MCR ();
    // enable_FRZ();
    // RSER_INIT ();
    // enable_SDADCs ();
    // RESET_KEY ();                                 
// }
/********************************************************/
/* SDADC_Offset :Configure SDADC to calibrate Offset    */
/* 					         						    */
/********************************************************/
void SDADC_Offset(void)
{

    FIFO_INIT ();
    OSD_config ();
    OffsetCal ();
    enable_FRZ();
    RSER_INIT ();
    enable_SDADCs ();
    RESET_KEY (); 
	
}
/********************************************************/
/* SDADC_Offset :Configure SDADC to calibrate Gain      */
/* 				:Returns Gain value	         	        */
/********************************************************/
uint32_t SDADC_GainCal(void)
{
 vint16_t  p 	 = 0x0;
 vint16_t  n 	 = 0x0;

    
	SDADC_1.MCR.B.MODE = 0x0;		     //Differential mode 
	SDADC_1.MCR.B.GECEN = 0x1;			 //Gain calibration mode enabled
	SDADC_1.CSR.B.BIASEN = 0x0;		     //ensure no bias connected to analog channel
	SDADC_1.CSR.B.ANCHSEL = 0x6;	     //VrefP = INP and VREFN = INM
    SDADC_1.MCR.B.PDR = 0x04;			 //configure OSR
	enable_FRZ();
	SDADC_1.MCR.B.PGAN = 0x0;			 //configure GAIN
	SDADC_1.MCR.B.EMSEL = 0x0;			 //configure EXT/INT Modulator
	SDADC_1.MCR.B.HPFEN = 0x0;			 //configure Hi Pass filter
	SDADC_1.MCR.B.VCOMSEL = 0x0;		 //Common ref = Vrefp/2 
    RESET_KEY ();    // Reset with the new configuration
	
	while (SDADC_1.SFR.B.CDVF !=1){}     // Poll Converted data valid flag
	while (SDADC_1.SFR.B.DFFF !=1){}     // Poll Data FIFO full flag
 {
 }
	p = SDADC_1.CDR.B.CDATA;
	SDADC_1.CSR.B.ANCHSEL = 0x7;	     //VrefN connected to INP and VrefP connected to INM
	RESET_KEY ();    // Reset with the new configuration
	
	while (SDADC_1.SFR.B.CDVF !=1){}     // Poll Converted data valid flag
	while (SDADC_1.SFR.B.DFFF !=1){}     // Poll Data FIFO full flag
 {
 }
	n = SDADC_1.CDR.B.CDATA;
	return ((p-n)/65536);            // Return gain error value
}

