
#include "../headers/MPC5777m.h"

#define MII_TIMEOUT 0x10000


#define FEC_RMII	(0)
#define FEC_MII		(1)

/*** FEC Buffer Structure and declarations ***/

#pragma c99 on
_Pragma("pack(1)")

typedef struct
{
    volatile unsigned short status;     /* Control and status info.*/
    volatile unsigned short length;              /* Data length.*/
    unsigned char *bufferPointer;             /* Buffer pointer.*/
}
BufferDescriptor;

_Pragma("pack()")

// initFec - setup the FEC, SIU and PHY
int initFec();

// isConnected - returns 1 is connected, otherwise 0
int isConnected();

// sendBuffer - send the next buffer, manage the descriptor pointer
void sendBuffer();

// Get the active rx descriptor
BufferDescriptor *getActiveRxDesc();

// Mark specified rx desc as empty
void markRxDescEmpty(BufferDescriptor *used);
